Looptober 2024
==============

This year for Looptober I decided to use my Arduino (in combination with my
modular synth rack) for every track. The source code for each day's track
is here and the tracks are on [my Funkwhale server](https://music.mikelynch.org/library/albums/31/)


## Track notes

### 1 Logistic

Using the [logistic map](https://en.wikipedia.org/wiki/Logistic_map) at an almost-chaotic point to control pitch

### 2 300 Baudrillard

The noise is the output from the logistic map as an audio-rate signal, sequencer is also the Arduino

### 3 Spoopy

Using my basic sequencer to drive three tracks. It goes out of sync because
the basic sequencer has bad timing.

### 4 Strong Fish's Fight Theme

I implemented the [Karplus-Strong algorithm](https://mikelynch.org/2024/Feb/03/buffer/) early this year, this is two tracks
of that with different filters applied in the modular.

### 5 Bad Wavetable

Using some very dodgy wavetable synthesis I did earlier this year

### 6 Cyber Jubilee

More of the wavetables but this time the aliasing adds to the effect

### 7 Mutations

Modifying a sequence as it's being played

### 8 Cellophane

First experiment with generating clouds of randomised gate signals

### 9 Stomp 7

More sequencing and a 7-TET tuning system. The timing errors really show up at
the end of this

### 10 Too Many LFOs

Using all four of the DAC's outputs as LFOs to drive a bunch of settings on 
two tracks of synths

### 11 Scratchpad

A beat made with Karplus-Strong through a waveshaper module and filter and
echo

### 12 Interrupt

I relearned what I'd forgotten about Arduino interrupts and got a sequencer
which can count time properly

### 13 Accidental FM

Accidentally made an FM synthesiser by plugging the Karplus-Strong rhythm into
a VCO's pitch control

### 14 Mondayitis

Trying to make something moody with the sequencer

### 15 Stretch

Trying to make something a bit funky with Karplus-Strong but that accidental
FM synth is crawling around in the background

### 16 Eggmeat for Rooroo

The accidental FM synthesiser being tweaked in two channels

### 17 Superheterodyne

Fiddling with sliders on one of my synth modules resulted in this scratchy
stuff

### 18 At Anchor

A better (I think) attempt at making something moody with the sequencer

### 19 Craquelure

Using the random-note-clouds technique from the 8th but this time picking
pitches from a hexany tuning, running it four times and drenching it in
reverb

### 20 Fibomod

Using the Fibonacci series modulo n, also known as the (Pisano period)[https://en.wikipedia.org/wiki/Pisano_period], as a wavetable, and incrementing n for each note in the sequence

### 21 Jacob's Ladder

Deliberate FM synthesis by using a wavetable as the control voltage of a VCO

### 22 Onomatopoeia

Triggering LFO patterns from the sequencer

### 23 Ha Ha

Using the triggering stuff from 22 to build a track with more structure

### 24 Wander

Another 7TET piece using the sequencer

### 25 Ribosome

Using the sequencer to trigger envelopes and LFOs at two scales - notes and
bars

### 26

Basic slew / portamento